Guidelines for the Definition of New Top Level Media Types
Internet-Draft draft-ietf-mediaman-toplevel-00
Martin J. Dürst
Aoyama Gakuin University
Fuchinobe 5-10-1, Chuo-ku, Sagamihara
Kanagawa
252-5258
Japan
+81 42 759 6329
duerst@it.aoyama.ac.jp
https://www.sw.it.aoyama.ac.jp/D%C3%BCrst/
2022
Applications and Real-Time
MEDIAMAN
Media Type, Top Level
The goal of this document is to identify best practices for defining new top-level media types. It updates RFC 6838, when approved. Comments and discussion about this document should be directed to media-types@ietf.org, the mailing list of the Media Type Maintenance (mediaman) WG.
Introduction
This document defines best practices for defining new top-level media types. RFC 6838 very consisely defines the conditions for defining additional top-level media types. This document expands this and therefore updates RFC 6838.
This document is currently a personal draft, but is intended for adoption by the Media Type Maintenance (mediaman) IETF WG. Comments and discussion about this document should be directed to that WG's mailing list at media-types@ietf.org.
Currently, this document is a collection of information, ideas, and text snippets that may be helpful in creating the actual specification. None of the current language is intended to be final.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in RFC 2119.
Top-Level Media Type History
This section shortly describes the history of top-level media types, with a particular emphasis on the (rather rare) adoption of new top-level types.
RFC 1341 first defined the structuring of content types into (top-level) type and subtype, and introduced the 'text', 'multipart', 'message', 'image', 'audio', 'video', and 'application' top-level types. That specification also allowed top-level types starting with 'X-'. With respect to new top-level types, it said the following:
An initial set of seven Content-Types is defined by this document. This set of top-level names is intended to be substantially complete. It is expected that additions to the larger set of supported types can generally be accomplished by the creation of new subtypes of these initial types. In the future, more top-level types may be defined only by an extension to this standard. If another primary type is to be used for any reason, it must be given a name starting with "X-" to indicate its non-standard status and to avoid a potential conflict with a future official name.
The first time an additional top-level type was defined was in RFC 1437, but this was purely for entertainment purposes (please check date).
RFC 2046 discouraged the use of "X-" for (new) top-level types, with the following words:
In general, the use of "X-" top-level types is strongly discouraged. Implementors should invent subtypes of the existing types whenever possible. In many cases, a subtype of "application" will be more appropriate than a new top-level type.
RFC 2048, published at the same time as RFC 2046, defined requirements for the definition of new top-level types:
In some cases a new media type may not "fit" under any currently defined top-level content type. Such cases are expected to be quite rare. However, if such a case arises a new top-level type can be defined to accommodate it. Such a definition must be done via standards-track RFC; no other mechanism can be used to define additional top-level content types.
The 'model' top-level type was introduced by RFC 2077 in 1997.
RFC 4735 introduced the 'example' top-level type for use in documentation examples.
The 'font' top-level media type was defined in RFC 8081, a work of the 'justfont' IETF WG, in 2017.
There is ongoing work on defining a new 'haptics' top-level media type in draft-ietf-mediaman-haptics.
Wikipedia (at https://en.wikipedia.org/wiki/Chemical_file_format) reports the unofficial use of a 'chemical' top-level type.
The document currently defining the requirements for new top-level media types is RFC 6838. Because we are trying to update what it says, we are citing the two relevant sections, Section 4.2.5 and Section 4.2.7, here.
4.2.5. Application Media Types
The "application" top-level type is to be used for discrete data that do not fit under any of the other type names, and particularly for data to be processed by some type of application program. This is information that must be processed by an application before it is viewable or usable by a user. Expected uses for the "application" type name include but are not limited to file transfer, spreadsheets, presentations, scheduling data, and languages for "active" (computational) material. (The last, in particular, can pose security problems that must be understood by implementors. The "application/postscript" media type registration in [RFC2046] provides a good example of how to handle these issues.)
For example, a meeting scheduler might define a standard representation for information about proposed meeting dates. An intelligent user agent would use this information to conduct a dialog with the user, and might then send additional material based on that dialog. More generally, there have been several "active" languages developed in which programs in a suitably specialized language are transported to a remote location and automatically run in the recipient's environment. Such applications may be defined as subtypes of the "application" top-level type.
The subtype of "application" will often either be the name or include part of the name of the application for which the data are intended. This does not mean, however, that any application program name may simply be used freely as a subtype of "application"; the subtype needs to be registered.
4.2.7. Additional Top-Level Types
In some cases, a new media type may not "fit" under any currently defined top-level type names. Such cases are expected to be quite rare. However, if such a case does arise, a new type name can be defined to accommodate it. Definition of a new top-level type name MUST be done via a Standards Track RFC; no other mechanism can be used to define additional type names.
The two sections above are not strictly aligned, because the first says anything that doesn't go under a more specific type can go under the 'application' top-level type, while the later section allows for new top-level types.
Potential Criteria for New Top-Level Media Types
This section describes potential criteria for new top-level media types, including criteria already defined in RFC 6838. Further work is needed to distinguish between required and optional criteria. But it is possible that we end up with just "we didn't find any objective criteria for new top-level types, and we will stop looking for such criteria".
- New top level types are rare enough and different enough that each application needs to be evaluated separately.
- Need to be documented in a Standards Track RFC.
- This Standards Track RFC should include initial registrations of actual types.
- May (or may not) need an IETF WG for definition.
- Existence of a certain number of subtypes that would be grouped under the new top-level type. At a minimum, one actual subtype should exist. But the existence of a single subtype should not be enough; it should be clear that new similar types may appear in the future.
- Existing wide use of an undefined top-level type may be an indication of a need, and therefore an argument for formally defining this new top-level type.
- On the other hand, the use of undefined top-level types is highly discouraged.
- Top-level types can help humans with understading and debugging. Therefore, evaluating how a new top-level type helps humans understand types may be crucial. But as often with humans, opinions may widely differ.
- Top-level types are also used frequently in dispatching code. For example "multipart/*" is frequently handled as multipart/mixed, without understanding of a specific subtype. The top-level media types 'image', 'audio', and 'video' are also often handled generically. Documents with these top-level media types can be passed to applications handling a wide variety of image, audio, or video formats. HTML generating applications can select different HTML elements (e.g. <img> or <audio>) for including data of different top-level types. Applications can select different icons to represent unknown types in different top-level types.
- Need for clear criteria for what types do and don't fall under the new top-level type.
- Desirability for common parameters: The fact that a group of (potential) types have (mostly) common parameters may be an indication that these belong under a common (new) top-level type.
IANA Considerations
There is currently no registry of top-level media types, but the list of top-level types available for registering subtypes is available at https://www.iana.org/assignments/media-types/media-types.xhtml.
There may be a question of whether there is a need for a formal registry of top-level types. Such a registry might contain pointers to the definitions of the top-level types. As a concrete example, the author of this document has not yet been able to find the definition of the 'model' top-level type.
Security Considerations
This document as such is not expected to introduce any security issues. The security issues of introducing a new top-level media type MUST be evaluated and documented carefully.
Changelog
RFC Editor, please remove this section before publication.
Changes from draft-duerst-mediaman-toplevel-00 to draft-ietf-mediaman-toplevel-01
- Add reference to RFC 2077 for definition of 'model' type.
- Add examples of use of top-level types for dispatch.
- Remove a stray '>' before the mention of RFC 4735.
- Change link to chemical/* Wikipedia page.
- Remove reference in abstract (pointed out by idnits).
Acknowledgements
Continuous encouragement for writing this draft came from Harald Alvestrand. Further encouragement was provided by Murray S. Kucherawy. Both Harald and Murray also provided ideas for actual text. Without them, this memo would never have reached even the first draft stage. Alexey Melnikov provided the difficult to find pointer to RFC 2077 and examples for applications dispatching on top level media types.
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
DOI 10.17487/RFC2119
RFC 2119
BCP 14
S. Bradner
March 1997
[RFC6838]

Media Type Specifications and Registration Procedures
N. Freed
J. Klensin
T. Hansen
January 2013
BCP 13
RFC 6838
DOI 10.17487/RFC6838
Informative References
[RFC1341]

MIME (Multipurpose Internet Mail Extensions): Mechanisms for Specifying and Describing the Format of Internet Message Bodies
N. Borenstein
N. Freed
June 1992
RFC 1341
DOI 10.17487/RFC1341
[RFC1437]

The Extension of MIME Content-Types to a New Medium
N. Borenstein
M. Linimon
April 1993
RFC 1437
DOI 10.17487/RFC1437
[RFC2046]

Multipurpose Internet Mail Extensions (MIME) Part Two: Media Types
N. Freed
N. Borenstein
November 1996
RFC 2046
DOI 10.17487/RFC2046
[RFC2048]

Multipurpose Internet Mail Extensions (MIME) Part Four: Registration Procedures
N. Freed
J. Klensin
J. Postel
November 1996
RFC 2048
DOI 10.17487/RFC2048
[RFC2077]

The Model Primary Content Type for Multipurpose Internet Mail Extensions
S. Nelson
C. Parks
Mitra
January 1997
RFC 2077
DOI 10.17487/RFC2077
[RFC4735]

Example Media Types for Use in Documentation
T. Taylor
October 2006
RFC 4735
DOI 10.17487/RFC4735
[RFC8081]

The "font" Top-Level Media Type
C. Lilley
February 2017
RFC 8081
DOI 10.17487/RFC8081
[HAPTICS]

The 'haptics' Top-level Media Type
RFC XXXX
Yeshwant K. Muthusamy
Immersion Corporation
Chris Ullrich
Immersion Corporation
Internet
MEDIAMAN